Analice, extraiga y estandarice las marcas de tiempo de los registros mediante plugins de procesamiento de tiempo nativos o de extensión.
Ejemplo del efecto del plugin
Comparación de datos de registro sin procesar en SLS con y sin el plugin de análisis de tiempo (nativo).
Registro sin procesar | Sin plugin | Plugin de análisis de tiempo (nativo) |
Marca de tiempo con precisión de segundos: | Content: "{"level":"INFO","timestamp":"2025-09-29T09:56:01+0800","cluster":"yilu-cluster-0728","message":"User logged in successfully","userId":"user-123"}" |
|
Marca de tiempo con precisión de milisegundos: | Content: "{"time":"2026-01-05T11:58:40,647Z", "filename":"out_data.py","levelname": "INFO", "threadName":"MainThread"}" |
|
Marca de tiempo con precisión de nanosegundos: | Content: "{"time": "2026-01-05T11:40:22,298837465Z07:00","filename":"out_data.py","levelname":"INFO","threadName": "MainThread"}" |
|
Plugins de procesamiento de tiempo
SLS proporciona los siguientes plugins de procesamiento de tiempo.
|
Nombre |
Tipo |
Descripción |
|
time parsing |
native |
Analiza y estandariza el campo de tiempo en los registros. |
|
extract log time |
extension |
Analiza el campo de tiempo sin procesar y lo establece como la marca de tiempo del registro. |
Punto de entrada
Para usar un plugin de Logtail en el procesamiento de registros, agréguelo al crear o modificar una configuración de Logtail. Para obtener más información, consulte Overview.
Diferencias entre plugins nativos y de extensión
Plugins nativos: Implementados en C++ para ofrecer un mayor rendimiento.
Plugins de extensión: Implementados en Go para proporcionar un ecosistema más amplio y flexible. Utilice plugins de extensión cuando los plugins nativos no puedan manejar su formato de registro.
-
Límites de rendimiento de los plugins de extensión
Los plugins de extensión consumen más recursos (principalmente CPU). Ajuste los parámetros de LoongCollector en configuration management si es necesario.
Si los datos sin procesar superan los 5 MB/s, evite combinaciones complejas de plugins. Use un plugin de extensión simple y delegue el procesamiento adicional a Data Transformation.
-
Límites de recolección de registros
Los plugins de extensión procesan registros de texto en modo de línea. Esto significa que los metadatos a nivel de archivo, como
__tag__:__path__y__topic__, se almacenan en cada entrada de registro.-
Agregar un plugin de extensión afecta las funciones relacionadas con etiquetas:
La consulta de contexto y LiveTail dejan de estar disponibles a menos que agregue una configuración de aggregators.
El campo
__topic__se renombra a__log_topic__. Al agregar la configuración de aggregators, el registro contiene tanto los campos__topic__como__log_topic__. Si no necesita el campo__log_topic__, puede usar drop field plugin para eliminarlo.Campos como
__tag__:__path__pierden su índice de campo nativo. Debe create an index para ellos.
Plugin de análisis de tiempo (nativo)
Analiza el campo de tiempo en un registro y asigna el resultado al campo __time__.
Configuración
Parámetro | Descripción |
Original Field | El campo que contiene el contenido del registro a analizar. Valor predeterminado: content. Nota Al usar el plugin de análisis regex, establezca el campo de origen en time e incluya time como un campo extraído en su configuración de regex. |
Time Format | El formato de la marca de tiempo en el registro. Por ejemplo, si la marca de tiempo es 10/Sep/2023:12:36:49, el formato de tiempo correspondiente es %d/%b/%Y:%H:%M:%S. |
Time Zone | La zona horaria de la marca de tiempo en el registro. Si se deja vacío, el plugin usa la zona horaria de la máquina donde se ejecuta Logtail. |
De forma predeterminada, Simple Log Service procesa las marcas de tiempo con precisión de segundos. Solo necesita configurar el formato de tiempo hasta los segundos y puede omitir unidades menores como milisegundos o microsegundos. Para conservar la precisión de milisegundos, microsegundos o nanosegundos, habilite la precisión de nanosegundos como se muestra a continuación. Log collection that supports nanosecond timestamps.
Registro sin procesar | Configuración del plugin de análisis de tiempo | Formato de tiempo |
| En el cuadro de diálogo de configuración de Processing Plugin, establezca Processing Plugin Type en Time Parsing, configure Source Field como | %Y-%m-%dT%H:%M:%S,%f |
Para habilitar la precisión de nanosegundos:
En la página de configuración de Logtail, vaya a , habilite Advanced Parameters e introduzca:
{
"EnableTimestampNanosecond": true
}
Habilite también EnableTimestampNanosecond cuando utilice plugins de extensión para analizar marcas de tiempo con precisión de nanosegundos o milisegundos.
Plugin extractor de tiempo de registro
Use processor_gotime o processor_strptime para analizar el campo de tiempo en registros sin procesar.
Para conservar la precisión inferior a un segundo, consulte Log collection that supports nanosecond timestamps.
Formato de tiempo Go (**processor_gotime**)
Formato de tiempo Strptime (**processor_strptime**)
Formatos de tiempo de registros
Para los formatos de tiempo de processor_gotime, consulte Constantes en el paquete de tiempo de Go. El plugin nativo processor_parse_timestamp_native y el plugin de extensión processor_strptime admiten los formatos que se enumeran a continuación.
En un servidor Linux, Logtail admite todos los formatos de tiempo proporcionados por la función strftime.
|
Formato |
Descripción |
Ejemplo |
|
%a |
Nombre abreviado del día de la semana. |
Fri |
|
%A |
Nombre completo del día de la semana. |
Friday |
|
%b |
Nombre abreviado del mes. |
Jan |
|
%B |
Nombre completo del mes. |
January |
|
%d |
Día del mes como número decimal con relleno de ceros (01-31). |
07, 31 |
|
%f |
Segundos fraccionarios, como milisegundos, microsegundos o nanosegundos. |
123 |
|
%h |
Nombre abreviado del mes. Equivalente a %b. |
Jan |
|
%H |
Hora (formato de 24 horas) como número decimal con relleno de ceros (00-23). |
22 |
|
%I |
Hora (formato de 12 horas) como número decimal con relleno de ceros (01-12). |
11 |
|
%m |
Mes como número decimal con relleno de ceros (01-12). |
08 |
|
%M |
Minuto como número decimal con relleno de ceros (00-59). |
59 |
|
%n |
Un salto de línea. |
salto de línea |
|
%p |
AM o PM. |
AM, PM |
|
%r |
Hora en formato de 12 horas. Equivalente a %I:%M:%S %p. |
11:59:59 AM |
|
%R |
Hora y minuto en formato de 24 horas. Equivalente a %H:%M. |
23:59 |
|
%S |
Segundo como número decimal con relleno de ceros (00-59). |
59 |
|
%t |
Un carácter de tabulación. |
Ninguna |
|
%y |
Año sin siglo como número decimal con relleno de ceros (00-99). |
04, 98 |
|
%Y |
Año con siglo como número decimal. |
2004, 1998 |
|
%C |
Siglo como número decimal (00-99). |
16 |
|
%e |
Día del mes como número decimal con relleno de espacios (1-31). |
7, 31 |
|
%j |
Día del año como número decimal con relleno de ceros (001-366). |
365 |
|
%u |
Día de la semana como número decimal, donde el lunes es 1 (1-7). |
2 |
|
%U |
Número de semana del año, con el domingo como primer día de la semana (00-53). |
23 |
|
%V |
Número de semana del año según ISO 8601, con el lunes como primer día de la semana (01-53). La semana 1 es la primera semana del año que contiene como mínimo cuatro días. |
24 |
|
%w |
Día de la semana como número decimal, donde el domingo es 0 (0-6). |
5 |
|
%W |
Número de semana del año, con el lunes como primer día de la semana (00-53). |
23 |
|
%c |
Representación de fecha y hora específica de la configuración regional. |
Tue Nov 20 14:12:58 2020 |
|
%x |
Representación de fecha específica de la configuración regional. |
Tue Nov 20 2020 |
|
%X |
Representación de hora específica de la configuración regional. |
11:59:59 |
|
%s |
Marca de tiempo Unix. |
1476187251 |
Ejemplos
Estándares de tiempo comunes y sus expresiones correspondientes:
|
Ejemplo |
Expresión |
Estándar |
|
2017-12-11 15:05:07 |
%Y-%m-%d %H:%M:%S |
Personalizado |
|
[2017-12-11 15:05:07.012] |
[%Y-%m-%d %H:%M:%S.%f] |
Personalizado |
|
2017-12-11 15:05:07.123 |
%Y-%m-%d %H:%M:%S.%f |
Personalizado |
|
02 Jan 06 15:04 MST |
%d %b %y %H:%M %Z |
RFC822 |
|
02 Jan 06 15:04 -0700 |
%d %b %y %H:%M %z |
RFC822Z |
|
Monday, 02-Jan-06 15:04:05 MST |
%A, %d-%b-%y %H:%M:%S %Z |
RFC850 |
|
Mon, 02 Jan 2006 15:04:05 MST |
%a, %d %b %Y %H:%M:%S %Z |
RFC1123 |
|
2006-01-02T15:04:05Z07:00 |
%Y-%m-%dT%H:%M:%S%z |
RFC3339 |
|
2006-01-02T15:04:05.999999999Z07:00 |
%Y-%m-%dT%H:%M:%S.%f%z |
RFC3339Nano |
|
1637843406 |
%s |
Personalizado |
|
1637843406123 |
%s |
Personalizado (Simple Log Service trunca las marcas de tiempo a precisión de segundos) |
Documentos relacionados
-
API de configuración de pipeline de Logtail:
-
Configuración de plugins desde la consola:
Collect container logs from a cluster using Kubernetes CRDs (standard output/file)


